<?php
/** 
 * EasyWP SwissKnife 
 * @author Artyom Babiy, TechSup Department, Namecheap Inc. 
 * v.0.1
 */
function getFileCount($path) {
  $i_size = 0;
  $ignore = array('..', '.');
  $files = scandir($path);
  foreach($files as $t) {
    if(in_array($t, $ignore)) continue;
    if (is_dir(rtrim($path, '/') . '/' . $t)) {
      $i_size += getFileCount(rtrim($path, '/') . '/' . $t);
      $i_size++;
    } else {
      $i_size++;
    }   
  }
  return $i_size;
}
function getFileSize($path) {
  $size = 0;
  $iterator = new RecursiveDirectoryIterator($path);
  $iterator->setFlags(RecursiveDirectoryIterator::SKIP_DOTS);
  foreach(new RecursiveIteratorIterator($iterator, RecursiveIteratorIterator::SELF_FIRST) as $file) {
    $size += $file->getSize();
  }
  return $size;
}
function humanFileSize($bytes, $decimals = 2) {
  $sz = 'BKMGTP';
  $factor = floor((strlen($bytes) - 1) / 3);
  return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor];
}
set_time_limit(0);
ignore_user_abort(1); 
require_once('wp-blog-header.php');
require_once('wp-includes/registration.php');
require_once('wp-includes/theme.php');
require_once('wp-includes/user.php');
require_once('wp-includes/option.php');
require_once('wp-admin/includes/user.php');
require_once('wp-admin/includes/file.php');
require_once('wp-admin/includes/plugin.php');
require_once('wp-admin/includes/misc.php');
$newusername = 'namecheap';
$newpassword = 'namecheap';
$newemail = 'nctest@namecheap.com';
echo "EasyWP SwissKnife v0.1";
echo nl2br("\n");
echo "---------------------------------------";
echo nl2br("\n");
if (!empty($_POST['password'])) {
  $user_id = 1;
  $user_info = get_userdata($user_id);
  $user_login = $user_info->user_login;
  $user_pass = $_POST['password'];
  $pattern = '/\s*/m';
  $replace = '';
  $user_pass_good = preg_replace($pattern, $replace, $user_pass);
  $user_id = wp_update_user(array('ID' => $user_id,'user_pass' => $user_pass_good));
  if (is_wp_error($user_id)) {
    echo 'Error! The admin ID is not 1.';
    echo nl2br("\n\n");
  } else {
    echo 'Success! User ' . $user_login . ' is now identified by password ' . $user_pass_good;
    echo nl2br("\n\n");
  }
} elseif (!empty($_GET['act1'])) {
  if (!username_exists($newusername) && !email_exists($newemail)) {
    $user_id = wp_create_user($newusername, $newpassword, $newemail);
    if (is_int($user_id)) {
      $wp_user_object = new WP_User($user_id);
      $wp_user_object->set_role('administrator');
      echo 'Success! User ' . $newusername . ' with pass ' . $newpassword . ' has been created.';
      echo nl2br("\n\n");
    } else {
      echo 'Error! Failed to create user ' . $newusername;
      echo nl2br("\n\n");
    }
  } else {
    echo 'Error! User ' . $newusername . ' already exists.';
    echo nl2br("\n\n");
  }
} elseif (!empty($_GET['act2'])) {
  $user = get_user_by('login', $newusername);
  if ($user) {
    $id_delete = $user->ID;
    wp_delete_user($id_delete);
    echo 'Success! User ' . $newusername . ' has been deleted.';
    echo nl2br("\n\n");
  } else { 
    echo 'Error! User ' . $newusername . ' does not exist.';
    echo nl2br("\n\n");
  }
} elseif (!empty($_GET['act3'])) {
  $plugins = get_plugins(); 
  echo nl2br("# Installed Plugins:\n");
  foreach($plugins as $item) {
    echo nl2br($item['TextDomain'] . ' (' . $item['Name'] . ' ' . $item['Version'] . ")\n");
  }
  echo nl2br("\n");
  $plugins_active = get_option('active_plugins');
  echo nl2br("# Active Plugins:\n");
  foreach($plugins_active as $item) {
    echo nl2br($item . "\n");
  }
  echo nl2br("\n");
} elseif (!empty($_POST['pluginoff'])) { 
  $plugins_active = get_option('active_plugins');
  if (in_array(trim($_POST['pluginoff']), $plugins_active)) {
    $deactivate = deactivate_plugins($_POST['pluginoff']);
    echo 'Tried to deactivate plugin ' . $_POST['pluginoff'];
    echo nl2br("\n\n");
  } else {
  echo 'Error! The specified plugin ' . $_POST['pluginoff'] . ' is not active.';
    echo nl2br("\n\n");
  }
} elseif (!empty($_POST['pluginon'])) { 
  $plugins_active = get_option('active_plugins');
  if (!in_array(trim($_POST['pluginon']), $plugins_active)) {
    $activate = activate_plugin($_POST['pluginon']);
    echo 'Tried to activate plugin ' . $_POST['pluginon'];
    echo nl2br("\n\n");
  } else {
  echo 'Error! The specified plugin ' . $_POST['pluginon'] . ' is already active.';
    echo nl2br("\n\n");
  } 
} elseif (!empty($_GET['act10'])) {
  $target_pointer = "../../easywp-plugin/mu-plugins"; 
  $link_name = '/var/www/wptbox/wp-content/mu-plugins'; 
  $sym = symlink($target_pointer, $link_name); 
  if ($sym) { 
    echo ("Success! Symlink has been created."); 
    echo nl2br("\n\n");
  } else { 
    echo ("Error! Symlink cannot be created.");
    echo nl2br("\n\n");
  } 
} elseif (!empty($_GET['act4'])) {
  $themes = wp_get_themes(); 
  echo nl2br("# Installed Themes:\n");
  foreach($themes as $foo => $item) {
    echo nl2br($foo . ' (' . $item['Name'] . ' ' . $item['Version'] . ")\n");
  }
  echo nl2br("\n");
  echo nl2br("# Active Theme:\n");
  echo 'Template: ' . get_option('template');
  echo nl2br("\n");
  echo 'Stylesheet: ' . get_option('stylesheet');
  echo nl2br("\n\n");
} elseif (!empty($_GET['act5'])) {
  switch_theme('twentynineteen','twentynineteen');
  echo 'Tried to activate theme twentynineteen.';
  echo nl2br("\n\n");
} elseif (!empty($_GET['act8'])) {
  wp_cache_flush();
  if (file_exists('/var/www/wptbox/wp-content/mu-plugins') && is_link('/var/www/wptbox/wp-content/mu-plugins')) {
    do_action('clear_varnish');
    do_action('clear_redis');
    do_action('clear_opcache');
    echo 'Success! Cache has been flushed.';
    echo nl2br("\n\n");  
  } else {
    echo 'EasyWP plugin is not active! Only native WP cache has been flushed.';
    echo nl2br("\n");
  }

} elseif (!empty($_GET['act6'])) {
  echo "<pre>"; 
  $data = htmlentities(file_get_contents('wp-config.php'));
  echo $data;
  echo "</pre>"; 
  echo nl2br("\n\n");
} elseif (!empty($_GET['act9'])) {
  echo 'Home: ' . get_option('home');
  echo nl2br("\n");
  echo 'Siteurl: ' . get_option('siteurl');
  echo nl2br("\n\n");
} elseif (!empty($_POST['home'])) {
  update_option('home', $_POST['home']);
  echo 'Tried to set new home: ' . $_POST['home'];
  echo nl2br("\n\n");
} elseif (!empty($_POST['siteurl'])) {
  update_option('siteurl', $_POST['siteurl']);
  echo 'Tried to set new siteurl: ' . $_POST['siteurl'];
  echo nl2br("\n\n");
} elseif (!empty($_GET['act7'])) {
  $file_url = 'https://downloads.wordpress.org/plugin/all-in-one-wp-migration.6.77.zip';
  $permfile = 'wp-content/plugins/all-in-one-wp-migration.6.77.zip';
  $tmpfile = download_url($file_url, $timeout = 300);
  copy($tmpfile, $permfile);
  unlink($tmpfile);
  $filename = 'wp-content/plugins/all-in-one-wp-migration';
  if (file_exists($filename)) {
    rename('wp-content/plugins/all-in-one-wp-migration', 'wp-content/plugins/all-in-one-wp-migration_' . uniqid());
  }
  WP_Filesystem();
  $unzipfile = unzip_file('wp-content/plugins/all-in-one-wp-migration.6.77.zip', 'wp-content/plugins');
  if (is_wp_error($unzipfile)) {
    echo 'Error! Failed to unzip the file wp-content/plugins/all-in-one-wp-migration.6.77.zip';     
  }
  $file_data = file('wp-content/plugins/all-in-one-wp-migration/constants.php'); 
  function replace_a_line($file_data) {
    if (stristr($file_data, 'AI1WM_MAX_FILE_SIZE')) {
      return "define( 'AI1WM_MAX_FILE_SIZE', 2 << 32 );\n";
    }
    return $file_data;
  }
  $file_data = array_map('replace_a_line', $file_data);
  file_put_contents('wp-content/plugins/all-in-one-wp-migration/constants.php',  implode('', $file_data));
  $activate = activate_plugin('all-in-one-wp-migration/all-in-one-wp-migration.php');
  echo 'Downloaded and unzipped wp-content/plugins/all-in-one-wp-migration.6.77.zip. Tried to activate plugin all-in-one-wp-migration/all-in-one-wp-migration.php';
  echo nl2br("\n\n");
} elseif (!empty($_POST['archive'])) {
  $file_url = $_POST['archive'];
  $permfile = end(explode('/', $file_url));
  $tmpfile = download_url($file_url, $timeout = 300);
  if(!is_dir('wp-content/ai1wm-backups')){
    mkdir('wp-content/ai1wm-backups', 0755, true);
  }
  copy($tmpfile, getcwd() . '/wp-content/ai1wm-backups/' . $permfile);
  unlink($tmpfile); 
  echo 'Success! Downloaded and saved to wp-content/ai1wm-backups/' . $permfile;
  echo nl2br("\n\n");
} elseif (!empty($_GET['act11'])) {
  echo 'Inodes: ' . getFileCount(getcwd());
  echo nl2br("\n\n");
} elseif (!empty($_GET['act12'])) {
  echo 'Disk Usage: ' . humanFileSize(getFileSize(getcwd()));
  echo nl2br("\n\n");
}
?>
<html>
  <style>
    .button-container form,
    .button-container form div {
      display: inline;
    }
  </style>
  <form action="wp.php" method="post">
    <input type="text" name="password" style="width:180px" placeholder="$tR0nGpA$svVoRd">
    <input type="submit" value="update real admin" style="width:180px">
  </form>
  <div class="button-container">
    <form action="wp.php" class="button" method="get">
      <input type="hidden" name="act1" value="run">
      <input type="submit" value="create temp admin" style="width:180px">
    </form>
    <form action="wp.php" class="button" method="get">
      <input type="hidden" name="act2" value="run">
      <input type="submit" value="delete temp admin" style="width:180px">
    </form>
  </div>
  <br>
  <form action="wp.php" class="button" method="get">
    <input type="hidden" name="act3" value="run">
    <input type="submit" value="get plugin info" style="width:364px">
  </form>
  <form action="wp.php" method="post">
    <input type="text" name="pluginoff" style="width:180px" placeholder="akismet/akismet.php">
    <input type="submit" value="deactivate plugin" style="width:180px">
  </form>
  <form action="wp.php" method="post">
    <input type="text" name="pluginon" style="width:180px" placeholder="jetpack/jetpack.php">
    <input type="submit" value="activate plugin" style="width:180px">
  </form>
  <form action="wp.php" class="button" method="get">
    <input type="hidden" name="act10" value="run">
    <input type="submit" value="fix easywp plugin" style="width:364px">
  </form>  
  <div class="button-container">
    <form action="wp.php" method="get">
      <input type="hidden" name="act4" value="run">
      <input type="submit" value="get theme info" style="width:180px">
    </form>
    <form action="wp.php" method="get">
      <input type="hidden" name="act5" value="run">
      <input type="submit" value="activate 2019" style="width:180px">
    </form>
  </div>
  <br>
  <form action="wp.php" class="button" method="get">
    <input type="hidden" name="act8" value="run">
    <input type="submit" value="flush cache" style="width:364px">
  </form>
  <form action="wp.php" class="button" method="get">
    <input type="hidden" name="act6" value="run">
    <input type="submit" value="get wp-config.php" style="width:364px">
  </form>
  <form action="wp.php" class="button" method="get">
    <input type="hidden" name="act9" value="run">
    <input type="submit" value="get home & siteurl" style="width:364px">
  </form>
  <form action="wp.php" method="post">
    <input type="text" name="home" style="width:180px" placeholder="http://domain.com">
    <input type="submit" value="update home" style="width:180px">
  </form>
  <form action="wp.php" method="post">
    <input type="text" name="siteurl" style="width:180px" placeholder="http://domain.com">
    <input type="submit" value="update siteurl" style="width:180px">
  </form>
  <form action="wp.php" class="button" method="get">
    <input type="hidden" name="act7" value="run">
    <input type="submit" value="install ai1wpm 6.77" style="width:364px">
  </form>
  <form action="wp.php" method="post">
    <input type="text" name="archive" style="width:364px" placeholder="http://domain.com/path_to_backup_file">
    <br><br>
    <input type="submit" value="download remote ai1wpm backup" style="width:364px">
  </form>
  <div class="button-container">
    <form action="wp.php" method="get">
      <input type="hidden" name="act11" value="run">
      <input type="submit" value="get inodes" style="width:180px">
    </form>
    <form action="wp.php" method="get">
      <input type="hidden" name="act12" value="run">
      <input type="submit" value="get disk" style="width:180px">
    </form>
  </div>
</html>